package net.geraldloeffler.tasktracker2006.dao;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.ejb.Stateless;
import net.geraldloeffler.tasktracker2006.domain.Entry;
import net.geraldloeffler.tasktracker2006.domain.Project;
import net.geraldloeffler.tasktracker2006.domain.Task;

/**
 * Fake implementation of Data Access Object (DAO) for Entry persistent domain
 * objects.
 * 
 * @author Gerald Loeffler
 */
@Stateless
public class EntryDAOBean implements EntryDAO {
  public Entry merge(Entry entry) {
    return entry;
  }
  
  public Entry findByID(int id) {
    final Project project = new Project("faked project");
    final Task task = new Task(project, "faked task");
    return new Entry(task, new Date(), "faked user");
  }

  public List<Entry> findAll() {
    return new ArrayList<Entry>();
  }

  public List<Entry> findActiveAtOrAfter(Date dateTime) {
    if (dateTime == null) throw new IllegalArgumentException("dateTime is null");
    return new ArrayList<Entry>();
  }

  public List<Entry> findActiveAtOrBefore(Date dateTime) {
    if (dateTime == null) throw new IllegalArgumentException("dateTime is null");
    return new ArrayList<Entry>();
  }

  public List<Entry> findActiveInPeriod(Date fromDateTime, Date toDateTime) {
    if (fromDateTime == null) throw new IllegalArgumentException(
        "fromDateTime is null");
    if (toDateTime == null) throw new IllegalArgumentException(
        "toDateTime is null");
    return new ArrayList<Entry>();
  }
}
